# Stubs for pyspark.ml.param.shared (Python 3)

from typing import Any, Generic, List
from pyspark.ml._typing import T

from pyspark.ml.param import *

class HasMaxIter(Params):
    maxIter: Param[int]
    def __init__(self) -> None: ...
    def setMaxIter(self: T, value: int) -> T: ...
    def getMaxIter(self) -> int: ...

class HasRegParam(Params):
    regParam: Param[float]
    def __init__(self) -> None: ...
    def setRegParam(self: T, value: float) -> T: ...
    def getRegParam(self) -> float: ...

class HasFeaturesCol(Params):
    featuresCol: Param[str]
    def __init__(self) -> None: ...
    def setFeaturesCol(self: T, value: str) -> T: ...
    def getFeaturesCol(self) -> str: ...

class HasLabelCol(Params):
    labelCol: Param[str]
    def __init__(self) -> None: ...
    def setLabelCol(self: T, value: str) -> T: ...
    def getLabelCol(self) -> str: ...

class HasPredictionCol(Params):
    predictionCol: Param[str]
    def __init__(self) -> None: ...
    def setPredictionCol(self: T, value: str) -> T: ...
    def getPredictionCol(self) -> str: ...

class HasProbabilityCol(Params):
    probabilityCol: Param[str]
    def __init__(self) -> None: ...
    def setProbabilityCol(self: T, value: str) -> T: ...
    def getProbabilityCol(self) -> str: ...

class HasRawPredictionCol(Params):
    rawPredictionCol: Param[str]
    def __init__(self) -> None: ...
    def setRawPredictionCol(self: T, value: str) -> T: ...
    def getRawPredictionCol(self) -> str: ...

class HasInputCol(Params):
    inputCol: Param[str]
    def __init__(self) -> None: ...
    def setInputCol(self: T, value: str) -> T: ...
    def getInputCol(self) -> str: ...

class HasInputCols(Params):
    inputCols: Param[List[str]]
    def __init__(self) -> None: ...
    def setInputCols(self: T, value: List[str]) -> T: ...
    def getInputCols(self) -> List[str]: ...

class HasOutputCol(Params):
    outputCol: Param[str]
    def __init__(self) -> None: ...
    def setOutputCol(self: T, value: str) -> T: ...
    def getOutputCol(self) -> str: ...

class HasOutputCols(Params):
    outputCols: Param[List[str]]
    def __init__(self) -> None: ...
    def setOutputCols(self: T, value: List[str]) -> T: ...
    def getOutputCols(self) -> List[str]: ...

class HasNumFeatures(Params):
    numFeatures: Param[int]
    def __init__(self) -> None: ...
    def setNumFeatures(self: T, value: int) -> T: ...
    def getNumFeatures(self) -> int: ...

class HasCheckpointInterval(Params):
    checkpointInterval: Param[int]
    def __init__(self) -> None: ...
    def setCheckpointInterval(self: T, value: int) -> T: ...
    def getCheckpointInterval(self) -> int: ...

class HasSeed(Params):
    seed: Param[int]
    def __init__(self) -> None: ...
    def setSeed(self: T, value: int) -> T: ...
    def getSeed(self) -> int: ...

class HasTol(Params):
    tol: Param[float]
    def __init__(self) -> None: ...
    def setTol(self: T, value: float) -> T: ...
    def getTol(self) -> float: ...

class HasStepSize(Params):
    stepSize: Param[float]
    def __init__(self) -> None: ...
    def setStepSize(self: T, value: float) -> T: ...
    def getStepSize(self) -> float: ...

class HasHandleInvalid(Params):
    handleInvalid: Param[str]
    def __init__(self) -> None: ...
    def setHandleInvalid(self: T, value: str) -> T: ...
    def getHandleInvalid(self) -> str: ...

class HasElasticNetParam(Params):
    elasticNetParam: Param[float]
    def __init__(self) -> None: ...
    def setElasticNetParam(self: T, value: float) -> T: ...
    def getElasticNetParam(self) -> float: ...

class HasFitIntercept(Params):
    fitIntercept: Param[bool]
    def __init__(self) -> None: ...
    def setFitIntercept(self: T, value: bool) -> T: ...
    def getFitIntercept(self) -> bool: ...

class HasStandardization(Params):
    standardization: Param[bool]
    def __init__(self) -> None: ...
    def setStandardization(self: T, value: bool) -> T: ...
    def getStandardization(self) -> bool: ...

class HasThresholds(Params):
    thresholds: Param[List[float]]
    def __init__(self) -> None: ...
    def setThresholds(self: T, value: List[float]) -> T: ...
    def getThresholds(self) -> List[float]: ...

class HasThreshold(Params):
    threshold: Param[float]
    def __init__(self) -> None: ...
    def setThreshold(self: T, value: float) -> T: ...
    def getThreshold(self) -> float: ...

class HasWeightCol(Params):
    weightCol: Param[str]
    def __init__(self) -> None: ...
    def setWeightCol(self: T, value: str) -> T: ...
    def getWeightCol(self) -> str: ...

class HasSolver(Params):
    solver: Param[str]
    def __init__(self) -> None: ...
    def setSolver(self: T, value: str) -> T: ...
    def getSolver(self) -> str: ...

class HasVarianceCol(Params):
    varianceCol: Param[str]
    def __init__(self) -> None: ...
    def setVarianceCol(self: T, value: str) -> T: ...
    def getVarianceCol(self) -> str: ...

class HasAggregationDepth(Params):
    aggregationDepth: Param[int]
    def __init__(self) -> None: ...
    def setAggregationDepth(self: T, value: int) -> T: ...
    def getAggregationDepth(self) -> int: ...

class HasParallelism(Params):
    parallelism: Param[int]
    def __init__(self) -> None: ...
    def setParallelism(self: T, value: int) -> T: ...
    def getParallelism(self) -> int: ...

class HasCollectSubModels(Params):
    collectSubModels: Param[bool]
    def __init__(self) -> None: ...
    def setCollectSubModels(self: T, value: bool) -> T: ...
    def getCollectSubModels(self) -> bool: ...

class HasLoss(Params):
    loss: Param[str]
    def __init__(self) -> None: ...
    def setLoss(self: T, value: str) -> T: ...
    def getLoss(self) -> str: ...

class DecisionTreeParams(Params):
    maxDepth: Param[int]
    maxBins: Param[int]
    minInstancesPerNode: Param[int]
    minInfoGain: Param[float]
    maxMemoryInMB: Param[int]
    cacheNodeIds: Param[bool]
    def __init__(self) -> None: ...
    def setMaxDepth(self: T, value: int) -> T: ...
    def getMaxDepth(self) -> int: ...
    def setMaxBins(self: T, value: int) -> T: ...
    def getMaxBins(self) -> int: ...
    def setMinInstancesPerNode(self: T, value: int) -> T: ...
    def getMinInstancesPerNode(self) -> int: ...
    def setMinInfoGain(self: T, value: float) -> T: ...
    def getMinInfoGain(self) -> float: ...
    def setMaxMemoryInMB(self: T, value: int) -> T: ...
    def getMaxMemoryInMB(self) -> int: ...
    def setCacheNodeIds(self: T, value: bool) -> T: ...
    def getCacheNodeIds(self) -> bool: ...

class HasDistanceMeasure(Params):
    distanceMeasure: Param[str]
    def __init__(self) -> None: ...
    def setDistanceMeasure(self: T, value: str) -> T: ...
    def getDistanceMeasure(self) -> str: ...
